diff --git a/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java b/src/main/java/net/minecraft/core/entity/player/Player.java
similarity index 75%
rename from src/main/java/net/minecraft/core/entity/player/EntityPlayer.java
rename to src/main/java/net/minecraft/core/entity/player/Player.java
index c689d17d5..9f0485ba7 100644
--- a/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java
+++ b/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -2,57 +2,59 @@ package net.minecraft.core.entity.player;
 
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
-import net.minecraft.core.achievement.AchievementList;
+import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.achievement.stat.StatList;
+import net.minecraft.core.block.BedBlock;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockBed;
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.entity.TileEntityDispenser;
-import net.minecraft.core.block.entity.TileEntityFlag;
-import net.minecraft.core.block.entity.TileEntityFurnace;
-import net.minecraft.core.block.entity.TileEntitySign;
-import net.minecraft.core.block.entity.TileEntityTrommel;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.DispenserBlockEntity;
+import net.minecraft.core.block.entity.FlagBlockEntity;
+import net.minecraft.core.block.entity.SignBlockEntity;
+import net.minecraft.core.block.entity.TrommelBlockEntity;
+import net.minecraft.core.block.entity.FurnaceBlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityBobber;
+import net.minecraft.core.entity.FishingBobberEntity;
 import net.minecraft.core.entity.EntityDispatcher;
-import net.minecraft.core.entity.EntityItem;
-import net.minecraft.core.entity.EntityLightningBolt;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.EntityTNT;
-import net.minecraft.core.entity.animal.EntityPig;
-import net.minecraft.core.entity.animal.EntityWolf;
-import net.minecraft.core.entity.monster.EntityCreeper;
-import net.minecraft.core.entity.monster.EntityGhast;
-import net.minecraft.core.entity.monster.EntityGiant;
-import net.minecraft.core.entity.monster.EntityMonster;
-import net.minecraft.core.entity.monster.EntityPigZombie;
-import net.minecraft.core.entity.monster.EntitySkeleton;
-import net.minecraft.core.entity.monster.EntitySlime;
-import net.minecraft.core.entity.monster.EntitySnowman;
-import net.minecraft.core.entity.monster.EntitySpider;
-import net.minecraft.core.entity.monster.EntityZombie;
-import net.minecraft.core.entity.projectile.EntityArrow;
-import net.minecraft.core.entity.projectile.EntityArrowGolden;
-import net.minecraft.core.entity.projectile.EntityCannonball;
-import net.minecraft.core.entity.projectile.EntityFireball;
-import net.minecraft.core.entity.vehicle.EntityBoat;
-import net.minecraft.core.entity.vehicle.EntityMinecart;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.LightningEntity;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.TNTPrimedEntity;
+import net.minecraft.core.entity.animal.PigMob;
+import net.minecraft.core.entity.animal.WolfMob;
+import net.minecraft.core.entity.monster.CreeperMob;
+import net.minecraft.core.entity.monster.GhastMob;
+import net.minecraft.core.entity.monster.GiantMob;
+import net.minecraft.core.entity.monster.Monster;
+import net.minecraft.core.entity.monster.ZombiePigMob;
+import net.minecraft.core.entity.monster.SkeletonMob;
+import net.minecraft.core.entity.monster.SlimeMob;
+import net.minecraft.core.entity.monster.SnowmanMob;
+import net.minecraft.core.entity.monster.SpiderMob;
+import net.minecraft.core.entity.monster.ZombieMob;
+import net.minecraft.core.entity.projectile.ArrowProjectile;
+import net.minecraft.core.entity.projectile.ArrowProjectileGolden;
+import net.minecraft.core.entity.projectile.CannonballProjectile;
+import net.minecraft.core.entity.projectile.FireballProjectile;
+import net.minecraft.core.entity.vehicle.BoatEntity;
+import net.minecraft.core.entity.vehicle.MinecartEntity;
 import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.enums.EnumSleepStatus;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.item.tool.ItemToolSword;
+import net.minecraft.core.item.tool.SwordToolItem;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.player.gamemode.Gamemode;
-import net.minecraft.core.player.inventory.Container;
-import net.minecraft.core.player.inventory.ContainerPlayer;
-import net.minecraft.core.player.inventory.IInventory;
-import net.minecraft.core.player.inventory.InventoryPlayer;
+import net.minecraft.core.player.inventory.menu.AbstractContainerMenu;
+import net.minecraft.core.player.inventory.menu.InventoryMenu;
+import net.minecraft.core.player.inventory.container.Container;
+import net.minecraft.core.player.inventory.container.Inventory;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
@@ -60,36 +62,77 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
-import net.minecraft.core.world.weather.Weather;
-import net.minecraft.server.entity.player.EntityPlayerMP;
+import net.minecraft.core.world.weather.Weathers;
+import net.minecraft.server.entity.player.ServerPlayer;
 
 import java.util.ArrayList;
 import java.util.Comparator;
 import java.util.Iterator;
 import java.util.List;
 
-public abstract class EntityPlayer extends EntityLiving
+public abstract class Player extends Mob
 {
     public static final TextFormatting deathMsgColor = TextFormatting.RED;
+    public Inventory inventory;
+    public AbstractContainerMenu inventorySlots;
+    public AbstractContainerMenu craftingInventory;
+    public Gamemode gamemode = Gamemode.survival;
+    //    public byte userType;
+    public int score;
+    public List<String> messageHistory = new ArrayList<>();
+    public float cameraVelocityOld;
+    public float cameraVelocity;
+    public boolean isSwinging;
+    public int swingProgressInt;
+    public String username;
+    public int dimension;
+    public double xdO;
+    public double ydO;
+    public double zd0;
+    protected boolean sleeping;
+    public ChunkCoordinates bedChunkCoordinates;
+    private int sleepTimer;
+    public float sleepOffX;
+    public float sleepOffY;
+    public float sleepOffZ;
+    private ChunkCoordinates playerSpawnCoordinate;
+    private ChunkCoordinates lastDeathCoordinate;
+    private ChunkCoordinates startMinecartRidingCoordinate;
+    public int timeUntilPortal;
+    protected boolean inPortal;
+    public int portalID;
+    public float timeInPortal;
+    public float prevTimeInPortal;
+    private final int damageRemainder;
+    public FishingBobberEntity bobberEntity;
+    public volatile String skinURL;
+    public volatile String capeURL;
+    public boolean slimModel = false;
+
+    protected float baseSpeed = 0.1f;
+    protected float baseFlySpeed = 0.02f;
+    protected boolean isDwarf = false;
+    public int lastRenderTick = 0;
+    public float wobbleTimer = 0;
 
-    public EntityPlayer(World world)
+    public Player(World world)
     {
         super(world);
-        inventory = new InventoryPlayer(this);
-        field_9371_f = 0;
+        inventory = new Inventory(this);
+//        userType = 0;
         score = 0;
         isSwinging = false;
         swingProgressInt = 0;
         timeUntilPortal = 20;
         inPortal = false;
         bobberEntity = null;
-        inventorySlots = new ContainerPlayer(inventory, !world.isClientSide);
+        inventorySlots = new InventoryMenu(inventory, !world.isClientSide);
         craftingInventory = inventorySlots;
         heightOffset = 1.62F;
         ChunkCoordinates chunkcoordinates = world.getSpawnPoint();
         moveTo((double)chunkcoordinates.x + 0.5D, chunkcoordinates.y + 1, (double)chunkcoordinates.z + 0.5D, 0.0F, 0.0F);
         entityType = "humanoid";
-        unusedRotation2 = 180F;
+//        rotOffs = 180F;
         fireImmuneTicks = 20;
         textureIdentifier = new NamespaceID("minecraft", "char");
         damageRemainder = 0;
@@ -129,9 +172,9 @@ public abstract class EntityPlayer extends EntityLiving
     }
 
     @Override
-	protected void init()
+	protected void defineSynchedData()
     {
-        super.init();
+        super.defineSynchedData();
         entityData.define(16, (byte) 0);
         entityData.define(17, (byte) 0); // selected art
         entityData.define(18, -1);
@@ -140,7 +183,7 @@ public abstract class EntityPlayer extends EntityLiving
     @Override
     public boolean canSkate() 
     {
-        return inventory.armorInventory[0] != null && inventory.armorInventory[0].itemID == Item.armorBootsIceskates.id;
+        return inventory.armorInventory[0] != null && inventory.armorInventory[0].itemID == Items.ARMOR_BOOTS_ICESKATES.id;
     }
 
     @Override
@@ -164,7 +207,7 @@ public abstract class EntityPlayer extends EntityLiving
                 {
                     wakeUpPlayer(true, true);
                 } else
-                if(world.isDaytime() && world.getCurrentWeather() != Weather.overworldStorm)
+                if(world.isDaytime() && world.getCurrentWeather() != Weathers.OVERWORLD_STORM)
                 {
                     wakeUpPlayer(false, true);
                 }
@@ -180,7 +223,7 @@ public abstract class EntityPlayer extends EntityLiving
         }
         super.tick();
 
-        if(!world.isClientSide && craftingInventory != null && !craftingInventory.isUsableByPlayer(this))
+        if(!world.isClientSide && craftingInventory != null && !craftingInventory.stillValid(this))
         {
             closeScreen();
             craftingInventory = inventorySlots;
@@ -227,7 +270,7 @@ public abstract class EntityPlayer extends EntityLiving
     }
 
     @Override
-    protected void updatePlayerActionState()
+    protected void updateAI()
     {
         if(isSwinging)
         {
@@ -264,7 +307,7 @@ public abstract class EntityPlayer extends EntityLiving
             flySpeed += (double)baseFlySpeed * 0.3;
         }
 
-        double velocity = MathHelper.sqrt_double(xd * xd + zd * zd);
+        double velocity = MathHelper.sqrt(xd * xd + zd * zd);
         double pitch = (float) Math.atan(-yd * 0.2D) * 15F;
         if(velocity > 0.1F)
         {
@@ -291,7 +334,7 @@ public abstract class EntityPlayer extends EntityLiving
 
         if(getHealth() > 0)
         {
-            List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(this, bb.expand(1.0D, 0.5D, 1.0D));
+            List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(this, bb.grow(1.0D, 0.5D, 1.0D));
             if(list != null)
             {
                 for (Entity entity : list) {
@@ -324,7 +367,7 @@ public abstract class EntityPlayer extends EntityLiving
     private void collideWithPlayer(Entity entity)
     {
         entity.playerTouch(this);
-        String entityName = EntityDispatcher.getEntityString(entity);
+        String entityName = EntityDispatcher.getEncodeId(entity);
         addStat(StatList.mobEncounterStats.get(entityName), 1);
     }
 
@@ -346,15 +389,15 @@ public abstract class EntityPlayer extends EntityLiving
         yd = 0.1d;
         if(username.equals("MaggAndGeez"))
         {
-            dropPlayerItemWithRandomChoice(new ItemStack(Item.ammoFireball, 1), true);
+            dropPlayerItemWithRandomChoice(new ItemStack(Items.AMMO_FIREBALL, 1), true);
         }
         else if (username.equals("jonkadelic"))
         {
-            dropPlayerItemWithRandomChoice(new ItemStack(Item.foodCookie, 1), true);
+            dropPlayerItemWithRandomChoice(new ItemStack(Items.FOOD_COOKIE, 1), true);
         }
         else if (username.equals("AnActualSign"))
         {
-            dropPlayerItemWithRandomChoice(new ItemStack(Item.sign, 1), true);
+            dropPlayerItemWithRandomChoice(new ItemStack(Items.SIGN, 1), true);
         }
         if (!world.getGameRuleValue(GameRules.KEEP_INVENTORY))
         {
@@ -363,8 +406,8 @@ public abstract class EntityPlayer extends EntityLiving
         }
         if(entityKilledBy != null)
         {
-            xd = -MathHelper.cos(((attackedAtYaw + yRot) * 3.141593F) / 180F) * 0.1F;
-            zd = -MathHelper.sin(((attackedAtYaw + yRot) * 3.141593F) / 180F) * 0.1F;
+            xd = -MathHelper.cos(((attackedAtYaw + yRot) * MathHelper.PI) / 180F) * 0.1F;
+            zd = -MathHelper.sin(((attackedAtYaw + yRot) * MathHelper.PI) / 180F) * 0.1F;
         } else
         {
             xd = zd = 0.0D;
@@ -382,9 +425,9 @@ public abstract class EntityPlayer extends EntityLiving
         {
             return getDisplayName() + deathMsgColor + " was killed by Herobrine.";
         }
-        if (entityKilledBy instanceof EntityZombie)
+        if (entityKilledBy instanceof ZombieMob)
         {
-            if (entityKilledBy instanceof EntityPigZombie)
+            if (entityKilledBy instanceof ZombiePigMob)
             {
                 return getDisplayName() + deathMsgColor + " discovered mob mentality.";
             }
@@ -393,113 +436,113 @@ public abstract class EntityPlayer extends EntityLiving
                 return getDisplayName() + deathMsgColor + " became a zombie.";
             }
         }
-        if (entityKilledBy instanceof EntityCreeper)
+        if (entityKilledBy instanceof CreeperMob)
         {
             return deathMsgColor + "Aw man, " + getDisplayName() + deathMsgColor + " didn't see the creeper.";
         }
-        if (entityKilledBy instanceof EntitySkeleton)
+        if (entityKilledBy instanceof SkeletonMob)
         {
             return getDisplayName() + deathMsgColor + " was a victim of aimbot.";
         }
-        if (entityKilledBy instanceof EntitySpider)
+        if (entityKilledBy instanceof SpiderMob)
         {
             return getDisplayName() + deathMsgColor + " spent too much time on the web.";
         }
-        if (entityKilledBy instanceof EntityGhast)
+        if (entityKilledBy instanceof GhastMob)
         {
             return getDisplayName() + deathMsgColor + " didn't return the serve.";
         }
-        if (entityKilledBy instanceof EntitySlime)
+        if (entityKilledBy instanceof SlimeMob)
         {
             return getDisplayName() + deathMsgColor + " was slimed.";
         }
-        if (entityKilledBy instanceof EntityWolf)
+        if (entityKilledBy instanceof WolfMob)
         {
             return getDisplayName() + deathMsgColor + " got what they deserved.";
         }
-        if (entityKilledBy instanceof EntityArrowGolden)
+        if (entityKilledBy instanceof ArrowProjectileGolden)
         {
-            if (((EntityArrowGolden) entityKilledBy).owner instanceof EntityPlayerMP)
+            if (((ArrowProjectileGolden) entityKilledBy).owner instanceof ServerPlayer)
             {
-                if (((EntityPlayerMP) ((EntityArrowGolden) entityKilledBy).owner).username.equals(username))
+                if (((ServerPlayer) ((ArrowProjectileGolden) entityKilledBy).owner).username.equals(username))
                 {
                     return getDisplayName() + deathMsgColor + " got gold in their eye.";
                 }
                 return getDisplayName() + deathMsgColor + " got pierced by " +
-                    ((EntityArrow) entityKilledBy).owner.getDisplayName() + deathMsgColor + ".";
+                    ((ArrowProjectile) entityKilledBy).owner.getDisplayName() + deathMsgColor + ".";
             }
             else
             {
                 return getDisplayName() + deathMsgColor + " is Swiss cheese.";
             }
         }
-        if (entityKilledBy instanceof EntityArrow)
+        if (entityKilledBy instanceof ArrowProjectile)
         {
-            if (((EntityArrow) entityKilledBy).owner instanceof EntitySkeleton)
+            if (((ArrowProjectile) entityKilledBy).owner instanceof SkeletonMob)
             {
                 return getDisplayName() + deathMsgColor + " was a victim of aimbot.";
             }
-            else if (((EntityArrow) entityKilledBy).owner instanceof EntityPlayerMP)
+            else if (((ArrowProjectile) entityKilledBy).owner instanceof ServerPlayer)
             {
-                if (((EntityPlayerMP) ((EntityArrow) entityKilledBy).owner).username.equals(username))
+                if (((ServerPlayer) ((ArrowProjectile) entityKilledBy).owner).username.equals(username))
                 {
                     return getDisplayName() + deathMsgColor + " lost a game of Russian roulette.";
                 }
                 return getDisplayName() + deathMsgColor + " got 360 noscoped by " +
-                    ((EntityArrow) entityKilledBy).owner.getDisplayName() + deathMsgColor + ".";
+                    ((ArrowProjectile) entityKilledBy).owner.getDisplayName() + deathMsgColor + ".";
             }
             else
             {
                 return getDisplayName() + deathMsgColor + " is a pincushion.";
             }
         }
-        if (entityKilledBy instanceof EntityCannonball)
+        if (entityKilledBy instanceof CannonballProjectile)
         {
-            if (((EntityCannonball) entityKilledBy).owner instanceof EntityPlayerMP)
+            if (((CannonballProjectile) entityKilledBy).owner instanceof ServerPlayer)
             {
-                if (((EntityPlayerMP) ((EntityCannonball) entityKilledBy).owner).username.equals(username))
+                if (((ServerPlayer) ((CannonballProjectile) entityKilledBy).owner).username.equals(username))
                 {
                     return getDisplayName() + deathMsgColor + " jumped too high.";
                 }
                 return getDisplayName() + deathMsgColor + " was fragmented by " +
-                    ((EntityCannonball) entityKilledBy).owner.getDisplayName() + deathMsgColor + ".";
+                    ((CannonballProjectile) entityKilledBy).owner.getDisplayName() + deathMsgColor + ".";
             }
             else
             {
                 return getDisplayName() + deathMsgColor + " was detonated remotely.";
             }
         }
-        if (entityKilledBy instanceof EntityFireball)
+        if (entityKilledBy instanceof FireballProjectile)
         {
             return getDisplayName() + deathMsgColor + " didn't return the serve.";
         }
-        if (entityKilledBy instanceof EntityGiant)
+        if (entityKilledBy instanceof GiantMob)
         {
             return getDisplayName() + deathMsgColor + " was killed by- wait, what?!";
         }
-        if (entityKilledBy instanceof EntityLightningBolt)
+        if (entityKilledBy instanceof LightningEntity)
         {
             return getDisplayName() + deathMsgColor + " was grounded.";
         }
-        if (entityKilledBy instanceof EntityTNT)
+        if (entityKilledBy instanceof TNTPrimedEntity)
         {
             return getDisplayName() + deathMsgColor + " was killed by Popbob.";
         }
-        if (entityKilledBy instanceof EntityPlayerMP)
+        if (entityKilledBy instanceof ServerPlayer)
         {
-            return getDisplayName() + deathMsgColor + " was backstabbed by " + ((EntityPlayerMP) entityKilledBy).getDisplayName() + deathMsgColor + ".";
+            return getDisplayName() + deathMsgColor + " was backstabbed by " + ((ServerPlayer) entityKilledBy).getDisplayName() + deathMsgColor + ".";
         }
-        if (entityKilledBy instanceof EntityPig)
+        if (entityKilledBy instanceof PigMob)
         {
             return getDisplayName() + deathMsgColor + " is *really* bad at Minecraft.";
         }
         else
         {
-            if (world.getBlockMaterial(MathHelper.floor_double(x), MathHelper.floor_double(y), MathHelper.floor_double(z)) == Material.lava)
+            if (world.getBlockMaterial(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z)) == Material.lava)
             {
                 return getDisplayName() + deathMsgColor + " got lost in the sauce.";
             }
-            if (world.getBlockId(MathHelper.floor_double(x), MathHelper.floor_double(y), MathHelper.floor_double(z)) == Block.spikes.id)
+            if (world.getBlockId(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z)) == Blocks.SPIKES.id)
             {
                 return getDisplayName() + deathMsgColor + " fell for the trap.";
             }
@@ -520,7 +563,7 @@ public abstract class EntityPlayer extends EntityLiving
     }
     
     @Override
-    protected void dropFewItems()
+    protected void dropDeathItems()
     {
     }
 
@@ -528,7 +571,7 @@ public abstract class EntityPlayer extends EntityLiving
 	public void awardKillScore(Entity entity, int i)
     {
         score += i;
-        if(entity instanceof EntityPlayer)
+        if(entity instanceof Player)
         {
             addStat(StatList.playerKillsStat, 1);
         } else
@@ -539,7 +582,7 @@ public abstract class EntityPlayer extends EntityLiving
 
     public void dropCurrentItem(boolean dropFullStack)
     {
-        dropPlayerItemWithRandomChoice(inventory.decrStackSize(inventory.currentItem, dropFullStack ? 64 : 1), false);
+        dropPlayerItemWithRandomChoice(inventory.removeItem(inventory.currentItem, dropFullStack ? 64 : 1), false);
     }
 
     public void dropPlayerItem(ItemStack itemstack)
@@ -589,24 +632,24 @@ public abstract class EntityPlayer extends EntityLiving
         {
             return;
         }
-        EntityItem entityitem = new EntityItem(world, x, (y - 0.30000001192092896D) + (double) this.getHeadHeight(), z, itemstack);
-        entityitem.delayBeforeCanPickup = 40;
+        ItemEntity entityitem = new ItemEntity(world, x, (y - 0.30000001192092896D) + (double) this.getHeadHeight(), z, itemstack);
+        entityitem.pickupDelay = 40;
         float f = 0.1F;
         if(flag)
         {
             float f2 = random.nextFloat() * 0.5F;
-            float f4 = random.nextFloat() * 3.141593F * 2.0F;
+            float f4 = random.nextFloat() * MathHelper.PI * 2.0F;
             entityitem.xd = -MathHelper.sin(f4) * f2;
             entityitem.zd = MathHelper.cos(f4) * f2;
-            entityitem.yd = 0.20000000298023224D;
+            entityitem.yd = 0.2D;
         } else
         {
             float f1 = 0.3F;
-            entityitem.xd = -MathHelper.sin((yRot / 180F) * 3.141593F) * MathHelper.cos((xRot / 180F) * 3.141593F) * f1;
-            entityitem.zd = MathHelper.cos((yRot / 180F) * 3.141593F) * MathHelper.cos((xRot / 180F) * 3.141593F) * f1;
-            entityitem.yd = -MathHelper.sin((xRot / 180F) * 3.141593F) * f1 + 0.1F;
+            entityitem.xd = -MathHelper.sin((yRot / 180F) * MathHelper.PI) * MathHelper.cos((xRot / 180F) * MathHelper.PI) * f1;
+            entityitem.zd = MathHelper.cos((yRot / 180F) * MathHelper.PI) * MathHelper.cos((xRot / 180F) * MathHelper.PI) * f1;
+            entityitem.yd = -MathHelper.sin((xRot / 180F) * MathHelper.PI) * f1 + 0.1F;
             f1 = 0.02F;
-            float f3 = random.nextFloat() * 3.141593F * 2.0F;
+            float f3 = random.nextFloat() * MathHelper.PI * 2.0F;
             f1 *= random.nextFloat();
             entityitem.xd += java.lang.Math.cos(f3) * (double)f1;
             entityitem.yd += (random.nextFloat() - random.nextFloat()) * 0.1F;
@@ -616,7 +659,7 @@ public abstract class EntityPlayer extends EntityLiving
         addStat(StatList.dropStat, 1);
     }
 
-    protected void joinEntityItemWithWorld(EntityItem entityitem)
+    protected void joinEntityItemWithWorld(ItemEntity entityitem)
     {
         world.entityJoinedWorld(entityitem);
     }
@@ -624,7 +667,7 @@ public abstract class EntityPlayer extends EntityLiving
     public float getCurrentPlayerStrVsBlock(Block block)
     {
         float f = inventory.getStrVsBlock(block);
-        float defaultBreakSpeed = (inventory.getCurrentItem() != null && inventory.getCurrentItem().getItem() instanceof ItemToolSword) ? 1.51f : 1.01f;
+        float defaultBreakSpeed = (inventory.getCurrentItem() != null && inventory.getCurrentItem().getItem() instanceof SwordToolItem) ? 1.51f : 1.01f;
         if (this.getGamemode().doesRequireToolToBreak() && f <= defaultBreakSpeed) return 0; // Requires to break and not effective against block
         if(isUnderLiquid(Material.water))
         {
@@ -658,7 +701,7 @@ public abstract class EntityPlayer extends EntityLiving
         noPhysics = tag.getBoolean("Noclip") && gamemode.canPlayerFly();
         if(sleeping)
         {
-            bedChunkCoordinates = new ChunkCoordinates(MathHelper.floor_double(x), MathHelper.floor_double(y), MathHelper.floor_double(z));
+            bedChunkCoordinates = new ChunkCoordinates(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z));
             wakeUpPlayer(true, true);
         }
         if(tag.containsKey("SpawnX") && tag.containsKey("SpawnY") && tag.containsKey("SpawnZ"))
@@ -706,7 +749,7 @@ public abstract class EntityPlayer extends EntityLiving
         return TextFormatting.get(chatColor) + name;
     }
 
-    public void displayGUIChest(IInventory iinventory)
+    public void displayGUIChest(Container iinventory)
     {
     }
 
@@ -725,7 +768,7 @@ public abstract class EntityPlayer extends EntityLiving
     public void displayGUIMobSpawnerPicker(int x, int y, int z) { }
     public void displayGUIWandMonsterPicker(ItemStack stack) { }
 
-    public void onItemPickup(Entity entity, int i)
+    public void onItemPickup(Entity entity, ItemStack item)
     {
     }
 
@@ -771,7 +814,7 @@ public abstract class EntityPlayer extends EntityLiving
         {
             wakeUpPlayer(true, true);
         }
-        if((attacker instanceof EntityMonster) || (attacker instanceof EntityArrow))
+        if((attacker instanceof Monster) || (attacker instanceof ArrowProjectile))
         {
             if(world.difficultySetting == 0)
             {
@@ -787,21 +830,21 @@ public abstract class EntityPlayer extends EntityLiving
             }
         }
         Object obj = attacker;
-        if (damage == 0 && !(attacker instanceof EntitySnowman))
+        if (damage == 0 && !(attacker instanceof SnowmanMob))
         {
             return false;
         }
-        if((obj instanceof EntityArrow) && ((EntityArrow)obj).owner != null)
+        if((obj instanceof ArrowProjectile) && ((ArrowProjectile)obj).owner != null)
         {
-            obj = ((EntityArrow)obj).owner;
+            obj = ((ArrowProjectile)obj).owner;
         }
-        if(obj instanceof EntityLiving)
+        if(obj instanceof Mob)
         {
-            alertWolves((EntityLiving)obj, false);
+            alertWolves((Mob)obj, false);
         }
         addStat(StatList.damageTakenStat, damage);
         if (attacker != null) {
-            String entityName = EntityDispatcher.getEntityString(attacker);
+            String entityName = EntityDispatcher.getEncodeId(attacker);
             addStat(StatList.mobEncounterStats.get(entityName), 1);
         }
 
@@ -813,25 +856,25 @@ public abstract class EntityPlayer extends EntityLiving
         return false;
     }
 
-    protected void alertWolves(EntityLiving entityliving, boolean flag)
+    protected void alertWolves(Mob entityliving, boolean flag)
     {
-        if((entityliving instanceof EntityCreeper) || (entityliving instanceof EntityGhast))
+        if((entityliving instanceof CreeperMob) || (entityliving instanceof GhastMob))
         {
             return;
         }
-        if(entityliving instanceof EntityWolf)
+        if(entityliving instanceof WolfMob)
         {
-            EntityWolf entitywolf = (EntityWolf)entityliving;
+            WolfMob entitywolf = (WolfMob)entityliving;
             if(entitywolf.isWolfTamed() && username.equals(entitywolf.getWolfOwner()))
             {
                 return;
             }
         }
-        if((entityliving instanceof EntityPlayer) && !func_27025_G())
+        if((entityliving instanceof Player) && !func_27025_G())
         {
             return;
         }
-        List list = world.getEntitiesWithinAABB(EntityWolf.class, AABB.getBoundingBoxFromPool(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).expand(16D, 4D, 16D));
+        List list = world.getEntitiesWithinAABB(WolfMob.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
         Iterator iterator = list.iterator();
         do
         {
@@ -840,7 +883,7 @@ public abstract class EntityPlayer extends EntityLiving
                 break;
             }
             Entity entity = (Entity)iterator.next();
-            EntityWolf entitywolf1 = (EntityWolf)entity;
+            WolfMob entitywolf1 = (WolfMob)entity;
             if(entitywolf1.isWolfTamed() && entitywolf1.getTarget() == null && username.equals(entitywolf1.getWolfOwner()) && (!flag || !entitywolf1.isWolfSitting()))
             {
                 entitywolf1.setWolfSitting(false);
@@ -869,32 +912,32 @@ public abstract class EntityPlayer extends EntityLiving
         super.damageEntity(newDamage, damageType);
     }
     
-    public void displayGUIFurnace(TileEntityFurnace tileentityfurnace)
+    public void displayGUIFurnace(FurnaceBlockEntity tileentityfurnace)
     {
     }
 
-    public void displayGUITrommel(TileEntityTrommel tileEntityTrommel)
+    public void displayGUITrommel(TrommelBlockEntity tileEntityTrommel)
     {
     }
 
-    public void displayGUIDispenser(TileEntityDispenser tileentitydispenser)
+    public void displayGUIDispenser(DispenserBlockEntity tileentitydispenser)
     {
     }
 
-    public void displayGUIGuidebook(TileEntityDispenser tileentitydispenser)
+    public void displayGUIGuidebook(DispenserBlockEntity tileentitydispenser)
     {
     }
 
-    public void displayGUIEditSign(TileEntitySign tileentitysign)
+    public void displayGUIEditSign(SignBlockEntity tileentitysign)
     {
     }
 
-    public void displayGUIEditFlag(TileEntityFlag tileEntityFlag)
+    public void displayGUIEditFlag(FlagBlockEntity tileEntityFlag)
     {
     }
 
     @Override
-    public boolean interact(EntityPlayer entityplayer) {
+    public boolean interact(Player entityplayer) {
         return false;
     }
 
@@ -907,9 +950,9 @@ public abstract class EntityPlayer extends EntityLiving
             flag = true;
         }
         ItemStack itemstack = getCurrentEquippedItem();
-        if(itemstack != null && (entity instanceof EntityLiving))
+        if(itemstack != null && (entity instanceof Mob))
         {
-            if (itemstack.useItemOnEntity((EntityLiving)entity, this))
+            if (itemstack.useItemOnEntity((Mob)entity, this))
             {
                 swingItem();
                 flag = true;
@@ -929,7 +972,7 @@ public abstract class EntityPlayer extends EntityLiving
 
     public void destroyCurrentEquippedItem()
     {
-        inventory.setInventorySlotContents(inventory.currentItem, null);
+        inventory.setItem(inventory.currentItem, null);
     }
 
     @Override
